package gq.unurled.raxen.commands;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.manager.StorageManager;
import gq.unurled.raxen.utils.Utils;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.event.ClickEvent;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.TabExecutor;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;

import java.util.List;

import static gq.unurled.raxen.utils.Utils.*;

public class RaxenCommand implements TabExecutor {

    private Raxen main;

    public RaxenCommand(Raxen main) {
        this.main = main;
    }

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command cmd, @NotNull String msg, @NotNull String[] args) {
        if(sender instanceof Player) {
            Player player = (Player) sender;
            if(!(player.hasPermission("raxen."))) {
                msgPlayer(player, Raxen.getPrefix() + color("&cYou can't execute this command. Insufficient permission."));
            }
            switch (args.length) {
                case 0 -> msgPl(player, 0);
                case 1 -> {
                    switch (args[0]) {
                        case "mongodb", "mongo", "MONGODB", "MONGO" -> {
                            //print info about connection
                            sender.sendMessage(Raxen.getPrefix() + color("&6Printing About Raxen's MongoDB connection..."));
                            msgPlayer(player, Raxen.getPrefix() + color("&6---------------------------------------------"),
                                    color("&cMONGO DB"));
                            msgPlayer(player, StorageManager.getMongo().getMongoClient().getClusterDescription().toString());
                            msgPlayer(player, StorageManager.getMongo().getMongoDatabase().getName());
                            msgPlayer(player, StorageManager.getMongo().getMongoCollection().getNamespace().toString());
                            msgPlayer(player, color("&6---------------------------------------------"));
                        }
                        case "v", "version", "ver" -> {
                            msgPl(player, 0);
                        }
                        case "hemlp", "?", "h" -> {
                            //print help
                        }
                    }
                }
            }
        }
        else {
            log(String.valueOf(args.length));
            switch (args.length) {
                case 0 -> {
                    sender.sendMessage(Raxen.getPrefix() + color("&6Printing About Raxen..."),
                            color("&6---------------------------------------------"),
                            color("&3                   Raxen                     "),
                            color("&3 - Version: " + Raxen.getVersion()),
                            color("&3 - Author: &l&cU&6n&eu&2r&al&be&3d&r"));
                    TextComponent txt = Component.text(color("&3 - Website: https://unurled.gq"));
                    sender.sendMessage(txt);
                    sender.sendMessage(color("&6---------------------------------------------"));
                    return true;
                }
                case 1 -> {
                    log("hello");
                    switch (args[0]) {
                        case "mongodb", "mongo", "MONGODB", "MONGO" -> {
                            //print info about connection
                            sender.sendMessage(Raxen.getPrefix() + color("&6Printing About Raxen's MongoDB connection..."));
                            sender.sendMessage(color("&6---------------------------------------------"), color("&cMONGO DB"));
                            sender.sendMessage(StorageManager.getMongo().getMongoClient().getClusterDescription().toString());
                            sender.sendMessage(StorageManager.getMongo().getMongoDatabase().getName());
                            sender.sendMessage(StorageManager.getMongo().getMongoCollection().getNamespace().toString());
                            sender.sendMessage(color("&6---------------------------------------------"));
                            return true;
                        }
                        case "v", "version", "ver" -> {
                            sender.sendMessage(Raxen.getPrefix() + color("&6Printing About Raxen..."),
                                    color("&6---------------------------------------------"),
                                    color("&3                   Raxen                     "),
                                    color("&3 - Version: " + Raxen.getVersion()),
                                    color("&3 - Author: &l&cU&6n&eu&2r&al&be&3d&r"));
                            TextComponent txt= Component.text(color("&3 - Website: https://unurled.gq"));
                            sender.sendMessage(txt);
                            sender.sendMessage(color("&6---------------------------------------------"));
                            return true;
                        }
                        case "hemlp", "?", "h" ->
                                //print help
                                log("why tf?");
                    }
                }
            }
        }
        return false;
    }

    public void msgPl(Player player, Integer in) {
        switch(in) {
            case 0:
                msgPlayer(player, Raxen.getPrefix() + color("&6Printing About Raxen..."),
                        color("&6---------------------------------------------"),
                        color("&3                   Raxen                     "),
                        color("&3 - Version: " + Raxen.getVersion()),
                        color("&3 - Author: &l&cU&6n&eu&2r&al&be&3d&r"));
                TextComponent txt = Component.text(color("&3 - Website: https://unurled.gq"))
                        .clickEvent(ClickEvent.openUrl("https://unurled.gq"));
                player.sendMessage(txt);
                msgPlayer(player, "", color("&6---------------------------------------------"));
        }
    }

    @Override
    public @Nullable List<String> onTabComplete(@NotNull CommandSender sender, @NotNull Command command, @NotNull String alias, @NotNull String[] args) {
        return null;
    }
}
