package gq.unurled.raxen.components.entity;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Attributes.Attribute;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;
import org.bukkit.entity.Entity;

public class Attributes {

    private static EntityNamespacedKey namespacedKey;

    public Attributes(Raxen main) {
        namespacedKey = new EntityNamespacedKey(main);
    }

    public static Attribute getAttribute(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        int health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg;
        health = data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
        itemHealth = data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
        defense = data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
        itemDefense = data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
        speed = data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
        itemSpeed = data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
        strength = data.get(namespacedKey.strengthKey , PersistentDataType.INTEGER);
        itemDmg = data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
        return new Attribute(health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg);
    }

    public static void setAttributes(Entity e, int health, int itemHealth, int defense, int itemDefense, int speed, int itemSpeed, int strength, int itemDmg) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, health);
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, itemHealth);
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, itemDefense);
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, speed);
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, itemSpeed);
        data.set(namespacedKey.strengthKey , PersistentDataType.INTEGER, strength);
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, itemDmg);
    }

    public void removeSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) -i);
    }

    public void removeItemSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) -i);
    }

    public void addSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) +i);
    }
    public void addHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) +i);
    }
    public void addDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) +i);
    }

    public void addItemSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) +i);
    }

    public Integer getSpeed(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
    }
    public Integer getStrength(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER);
    }
    public Integer getHealth(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
    }
    public Integer getDefense(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
    }

    public Integer getItemSpeed(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
    }
    public Integer getItemStrength(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemHealth(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemDefense(Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        return data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
    }

    public void setHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, i);
    }
    public void setDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, i);
    }
    public void setSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, i);
    }
    public void setStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, i);
    }

    public void setItemHealth(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, i);
    }
    public void setItemDefense(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, i);
    }
    public void setItemSpeed(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, i);
    }
    public void setItemStrength(Entity e, int i) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, i);
    }
}
