package gq.unurled.raxen.components.entity;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Attributes.Attribute;
import org.bukkit.entity.LivingEntity;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import static gq.unurled.raxen.utils.Utils.log;
import static gq.unurled.raxen.utils.Utils.msgPlayer;

public class Entity {

    private static Raxen main;
    private static EntityNamespacedKey namespacedKey;

    public Entity(Raxen main) {
        main = main;
        namespacedKey = new EntityNamespacedKey(main);
    }

    public static void setNameSpacedKeys(org.bukkit.entity.Entity e, String name, Integer level, int health, int itemHealth, int defense, int itemDefense, int speed, int itemSpeed, int strength, int itemDmg) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, health);
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, itemHealth);
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, speed);
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, itemSpeed);
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, strength);
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, itemDmg);
        data.set(namespacedKey.nameKey, PersistentDataType.STRING, name);
        data.set(namespacedKey.levelKey, PersistentDataType.INTEGER, level);
    }

    public static Attribute getattributesEntity(org.bukkit.entity.Entity e) {
        PersistentDataContainer data = e.getPersistentDataContainer();
        int health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg;
        health = data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
        itemHealth = data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
        defense = data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
        itemDefense = data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
        speed = data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
        itemSpeed = data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
        strength = data.get(namespacedKey.strengthKey , PersistentDataType.INTEGER);
        itemDmg = data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
        return new Attribute(health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg);
    }

    public static void updateSkills(LivingEntity livingEntity) {
        Attributes attributes = new Attributes(main);
        int health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg;
        org.bukkit.entity.Entity e = livingEntity;
        health = attributes.getHealth(e);
        itemHealth = attributes.getItemHealth(e);
        defense = attributes.getDefense(e);
        itemDefense = attributes.getItemDefense(e);
        speed = attributes.getSpeed(e);
        itemSpeed = attributes.getItemSpeed(e);
        strength = attributes.getStrength(e);
        itemDmg = attributes.getItemStrength(e);
        livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_MAX_HEALTH).setBaseValue(20D + (health + itemHealth) / 100);
        livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_FLYING_SPEED).setBaseValue((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
        livingEntity.getAttribute(org.bukkit.attribute.Attribute.GENERIC_MOVEMENT_SPEED).setBaseValue((float) (0.0 + ((speed + itemSpeed) / 100) * 0.2));
        log("Speed " + (speed + itemSpeed), "Health " + (health + itemHealth), "Defense " + (defense+itemDefense), "Strength " + (strength+itemDmg));
    }

}
