package gq.unurled.raxen.components.entity;

import gq.unurled.raxen.Raxen;
import org.bukkit.Location;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

public class RaxenEntity {

    private final Raxen main;

    private final String name;
    private Integer level;
    private Double health;
    private Double strength;

    public RaxenEntity(Raxen main, String name, Integer level, Double health, Double strength) {
        this.main = main;
        this.name = name;
        this.level = level;
        this.health = health;
        this.strength = strength;
    }

    public Entity createEntity(EntityType type, String name, Location location) {
        Entity e = location.getWorld().spawnEntity(location, type);
        e.setCustomNameVisible(true);
        e.setCustomName(name);

        return e;
    }

    public void register(Entity e) {
        PersistentDataContainer data  = e.getPersistentDataContainer();
        data.set(new NamespacedKey(main ,"NAME"), PersistentDataType.STRING, name);
    }

}
