package gq.unurled.raxen.components.player.Attributes;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.EntityNamespacedKey;
import lombok.Getter;
import lombok.Setter;
import org.bukkit.entity.Player;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

public class Attributes {

    private static EntityNamespacedKey namespacedKey;

    public Attributes(Raxen main) {
        namespacedKey = new EntityNamespacedKey(main);
    }

    public static Attribute getAttribute(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        int health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg;
        health = data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
        itemHealth = data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
        defense = data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
        itemDefense = data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
        speed = data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
        itemSpeed = data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
        strength = data.get(namespacedKey.strengthKey , PersistentDataType.INTEGER);
        itemDmg = data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
        return new Attribute(health, itemHealth, defense, itemDefense, speed, itemSpeed, strength, itemDmg);
    }

    public static void setAttributes(Player player, int health, int itemHealth, int defense, int itemDefense, int speed, int itemSpeed, int strength, int itemDmg) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, health);
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, itemHealth);
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, defense);
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, itemDefense);
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, speed);
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, itemSpeed);
        data.set(namespacedKey.strengthKey , PersistentDataType.INTEGER, strength);
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, itemDmg);
    }

    public void removeSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) -i);
    }

    public void removeItemSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER) -i);
    }
    public void removeItemStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) -i);
    }

    public void addSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, data.get(namespacedKey.speedKey, PersistentDataType.INTEGER) +i);
    }
    public void addHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, data.get(namespacedKey.healthKey, PersistentDataType.INTEGER) +i);
    }
    public void addDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER) +i);
    }

    public void addItemSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER) +i);
    }
    public void addItemStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER) +i);
    }

    public Integer getSpeed(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.speedKey, PersistentDataType.INTEGER);
    }
    public Integer getStrength(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.strengthKey, PersistentDataType.INTEGER);
    }
    public Integer getHealth(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.healthKey, PersistentDataType.INTEGER);
    }
    public Integer getDefense(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.defenseKey, PersistentDataType.INTEGER);
    }

    public Integer getItemSpeed(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER);
    }
    public Integer getItemStrength(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemHealth(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemHealthKey, PersistentDataType.INTEGER);
    }
    public Integer getItemDefense(Player player) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        return data.get(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER);
    }

    public void setHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.healthKey, PersistentDataType.INTEGER, i);
    }
    public void setDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.defenseKey, PersistentDataType.INTEGER, i);
    }
    public void setSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.speedKey, PersistentDataType.INTEGER, i);
    }
    public void setStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.strengthKey, PersistentDataType.INTEGER, i);
    }

    public void setItemHealth(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemHealthKey, PersistentDataType.INTEGER, i);
    }
    public void setItemDefense(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemDefenseKey, PersistentDataType.INTEGER, i);
    }
    public void setItemSpeed(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemSpeedKey, PersistentDataType.INTEGER, i);
    }
    public void setItemStrength(Player player, int i) {
        PersistentDataContainer data = player.getPersistentDataContainer();
        data.set(namespacedKey.itemStrengthKey, PersistentDataType.INTEGER, i);
    }
}
