package gq.unurled.raxen.config;

import gq.unurled.raxen.Raxen;
import lombok.Getter;
import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

import static gq.unurled.raxen.utils.Utils.log;

public class Config {
    private Raxen main;

    private File configFile;

    @Getter
    private FileConfiguration config;


    public Config(Raxen main) {
        this.main = main;
        this.config = main.getConfig();
        this.init();
    }

    public void init() {
        FileConfiguration config = main.getConfig();
        File configFile = new File(main.getDataFolder() + "/config.yml");
        if (!(configFile.exists())) {
            main.saveDefaultConfig();
        }
        FileConfiguration conf = new YamlConfiguration();
        log(config.getString("version"));
        try {
            conf.load(configFile);
        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
        log(conf.getString("version"));
        if(!Raxen.getVersion().equals(config.getString("version"))){
            main.saveResource("config.yml", true);
        }
    }

}
