package gq.unurled.raxen.listener.entity;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.entity.EntityNamespacedKey;
import gq.unurled.raxen.components.items.Attributes;
import gq.unurled.raxen.manager.ProfileManager;
import gq.unurled.raxen.utils.Items;
import org.bukkit.attribute.Attribute;
import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.persistence.PersistentDataContainer;
import org.bukkit.persistence.PersistentDataType;

import static gq.unurled.raxen.utils.Utils.log;

public class DamageEntity implements Listener {
    private Raxen main;
    private ProfileManager profileManager;
    private EntityNamespacedKey entityNamespacedKey;

    public DamageEntity(Raxen main) {
        this.main = main;
        this.profileManager = main.getProfileManager();
        this.entityNamespacedKey = new EntityNamespacedKey(main);
    }

    @EventHandler
    public void entityDamageByEntity(EntityDamageByEntityEvent e) {
        e.setDamage(0);
        Integer damage = 1;
        Integer strength = 0;
        Integer itemDmg = 0;
        Integer defense = 0;
        Integer itemDefense = 0;
        Integer health = 0;
        Integer itemHealth = 0;
        Integer initDamage = 0;
        log(e.getEntity().getName(), e.getEntity().getType().toString(), e.getDamager().getType().toString(), e.getDamager().getName());
        if (e.getDamager() instanceof Player) {
            Player playerDamager = (Player) e.getDamager();
            gq.unurled.raxen.components.player.Attributes.Attributes attributes = new gq.unurled.raxen.components.player.Attributes.Attributes(main);
            strength = attributes.getStrength(playerDamager);
            itemDmg = attributes.getItemStrength(playerDamager);
        } else {
            Entity entityDamager = e.getDamager();
            PersistentDataContainer data = entityDamager.getPersistentDataContainer();
            if (data.has(entityNamespacedKey.strengthKey, PersistentDataType.INTEGER)) {
                strength = data.get(entityNamespacedKey.strengthKey, PersistentDataType.INTEGER);
            }
            Attributes attributes = Items.getNbtFromEntity((LivingEntity) entityDamager);
            itemDmg = attributes.getStrength();
        }
        if (e.getEntity() instanceof Player) {
            Player playerVictim = (Player) e.getEntity();
            gq.unurled.raxen.components.player.Attributes.Attributes attributes = new gq.unurled.raxen.components.player.Attributes.Attributes(main);
            defense = attributes.getDefense(playerVictim);
            health = attributes.getHealth(playerVictim);
            itemDefense = attributes.getItemDefense(playerVictim);
            itemHealth = attributes.getItemHealth(playerVictim);
        } else {
            Entity entityVictim = e.getEntity();
            PersistentDataContainer data = entityVictim.getPersistentDataContainer();
            if (data.has(entityNamespacedKey.defenseKey, PersistentDataType.INTEGER)) {
                defense = data.get(entityNamespacedKey.defenseKey, PersistentDataType.INTEGER);
            }
            if (data.has(entityNamespacedKey.healthKey, PersistentDataType.INTEGER)) {
                health = data.get(entityNamespacedKey.healthKey, PersistentDataType.INTEGER);
            }
            Attributes attributes = Items.getNbtFromEntity((LivingEntity) entityVictim);
            itemDefense = attributes.getDefense();
            itemHealth = attributes.getHealth();
        }
        initDamage = (5+ itemDmg) * (1+ (strength/100));
        damage = initDamage;
        defense = defense + itemDefense;
        log(String.valueOf(damage));
        defense = defense/(defense+100);
        log(String.valueOf(damage));
        log(String.valueOf(defense));
        Integer health_with_defense = health * (1+ (defense/100));
        log(String.valueOf(damage));
        log(String.valueOf(health));
        log(String.valueOf(health_with_defense));
        if (damage >= health_with_defense) {
            e.setDamage(e.getEntity().getType().getDefaultAttributes().getAttribute(Attribute.GENERIC_MAX_HEALTH).getDefaultValue());
        } else {
            health = health_with_defense - health - damage;
            if (e.getEntity() instanceof Player) {
                Player playerVictim = (Player) e.getEntity();
                gq.unurled.raxen.components.player.Attributes.Attributes attributes = new gq.unurled.raxen.components.player.Attributes.Attributes(main);
                attributes.setHealth(playerVictim, health);
            } else {
                Entity entityVictim = e.getEntity();
                PersistentDataContainer data = entityVictim.getPersistentDataContainer();
                data.set(entityNamespacedKey.healthKey, PersistentDataType.INTEGER, health);
            }
        }
    }
}
