package gq.unurled.raxen.listener.player;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.player.Scoreboard;
import gq.unurled.raxen.components.resourcepack.ResourcePack;
import gq.unurled.raxen.config.PlayerConfig;
import gq.unurled.raxen.manager.ProfileManager;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

public class JoinEvent implements Listener {

    private Raxen main;
    private ProfileManager profileManager;
    private PlayerConfig playerConfig;
    private Scoreboard scoreboard;
    private ResourcePack resourcePack;

    public JoinEvent(Raxen main) {
        this.main = main;
        this.profileManager = main.getProfileManager();
        this.playerConfig = main.getPlayerConfig();
        this.scoreboard = new Scoreboard(main);
        this.resourcePack = main.getResourcePackManager().getResourcePack();
    }

    @EventHandler
    public void PlayerJoinEvent(PlayerJoinEvent e) {
        Player player = e.getPlayer();
        playerConfig.loadPlayerConfig(player);
        scoreboard.createScorebord(player);
        resourcePack.join(player);
    }

}
