package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.commands.RaxenCommand;
import gq.unurled.raxen.commands.admin.ItemListCommand;
import gq.unurled.raxen.commands.admin.NbtCommand;
import gq.unurled.raxen.commands.admin.ReloadCommand;
import gq.unurled.raxen.commands.admin.TestGuiCommand;
import gq.unurled.raxen.commands.player.SkillsCommand;
import gq.unurled.raxen.commands.player.StorageCommand;
import lombok.Getter;


public class CommandManager {

    private Raxen main;
    @Getter
    private ItemListCommand itemListCommand;
    private ReloadCommand reloadComand = new ReloadCommand();
    private NbtCommand nbtCommand = new NbtCommand(main);
    private TestGuiCommand testGuiCommand = new TestGuiCommand();
    private StorageCommand storageCommand = new StorageCommand();
    private SkillsCommand skillsCommand = new SkillsCommand(main);
    private RaxenCommand raxenCommand = new RaxenCommand(main);

    public CommandManager(Raxen main) {
        this.main = main;
        this.itemListCommand = new ItemListCommand(this.main);
    }

    public void register() {
        main.getCommand("reloadplugin").setExecutor(reloadComand);
        main.getCommand("reloadplugin").setTabCompleter(reloadComand);

        main.getCommand("nbt").setExecutor(nbtCommand);
        main.getCommand("nbt").setTabCompleter(nbtCommand);

        main.getCommand("testgui").setExecutor(testGuiCommand);
        main.getCommand("testgui").setTabCompleter(testGuiCommand);

        main.getCommand("storage").setExecutor(storageCommand);
        main.getCommand("storage").setTabCompleter(storageCommand);


        main.getCommand("skills").setTabCompleter(skillsCommand);
        main.getCommand("skills").setExecutor(skillsCommand);

        main.getCommand("raxen").setTabCompleter(raxenCommand);
        main.getCommand("raxen").setExecutor(raxenCommand);

        main.getCommand("itemlist").setExecutor(itemListCommand);
        main.getCommand("itemlist").setTabCompleter(itemListCommand);
    }

}
