package gq.unurled.raxen.manager;

import gq.unurled.raxen.Raxen;
import gq.unurled.raxen.components.resourcepack.ResourcePack;
import lombok.Getter;
import org.bukkit.configuration.file.FileConfiguration;

import java.util.Objects;

import static gq.unurled.raxen.utils.Utils.error;
import static gq.unurled.raxen.utils.Utils.log;

public class ResourcePackManager {

    private Raxen main;
    @Getter
    private ResourcePack resourcePack;
    private FileConfiguration config;
    @Getter
    private boolean useRP;

    public ResourcePackManager(Raxen main) {
        this.main = main;
        this.resourcePack = new ResourcePack(main, this);
        this.config = main.getConfig();
        this.useRP = this.config.getBoolean("useResourcePack");
        enable();
    }

    private void enable() {
        if(useRP) {
            if(config.getString("resource_pack_url") == null || Objects.equals(config.getString("rssource_pack_url"), "") ||
                    config.getString("resource_pack_sha1") == null || Objects.equals(config.getString("resource_pack_sha1"), "") ||
                    Objects.equals(config.getString("resource_pack_url"), "https://mc-packs.net/") || Objects.equals(config.getString("resource_pack_sha1"), "sha1hallo")) {
                error("You must specify an resource_pack_url and resource_pack_sha1!");
                log("Resource pack not enabled.");
                useRP = false;
            } else {
                log("Ressource Pack enabled.");
            }
        } else {
            log("Resource pack not enabled.");
        }

    }
}
